searchData={"items":[{"type":"module","title":"Logster","doc":"Single line, easy to parse logs for Elixir Phoenix and Plug applications.\n\nSee the project [README](https://github.com/navinpeiris/logster) for more details.","ref":"Logster.html"},{"type":"function","title":"Logster.alert/2","doc":"Logs a alert message. See `Logster.log/3` for more information.\n\nReturns `:ok`.","ref":"Logster.html#alert/2"},{"type":"function","title":"Logster.attach_phoenix_logger/0","doc":"Attaches a telemetry handler to the `:phoenix` event stream for logging.\n\nReturns `:ok`.","ref":"Logster.html#attach_phoenix_logger/0"},{"type":"function","title":"Logster.critical/2","doc":"Logs a critical message. See `Logster.log/3` for more information.\n\nReturns `:ok`.","ref":"Logster.html#critical/2"},{"type":"function","title":"Logster.debug/2","doc":"Logs a debug message. See `Logster.log/3` for more information.\n\nReturns `:ok`.","ref":"Logster.html#debug/2"},{"type":"function","title":"Logster.detach_phoenix_logger/0","doc":"Detaches logster's telemetry handler from the `:phoenix` event stream.\n\nReturns `:ok`.","ref":"Logster.html#detach_phoenix_logger/0"},{"type":"function","title":"Logster.emergency/2","doc":"Logs a emergency message. See `Logster.log/3` for more information.\n\nReturns `:ok`.","ref":"Logster.html#emergency/2"},{"type":"function","title":"Logster.error/2","doc":"Logs a error message. See `Logster.log/3` for more information.\n\nReturns `:ok`.","ref":"Logster.html#error/2"},{"type":"type","title":"Logster.fields_or_message_or_func/0","doc":"","ref":"Logster.html#t:fields_or_message_or_func/0"},{"type":"function","title":"Logster.info/2","doc":"Logs a info message. See `Logster.log/3` for more information.\n\nReturns `:ok`.","ref":"Logster.html#info/2"},{"type":"function","title":"Logster.levels/0","doc":"","ref":"Logster.html#levels/0"},{"type":"function","title":"Logster.log/3","doc":"Logs a message with the given `level`.\n\nIf given an enumerable, the enumerable will be formatted using the configured formatter.\n\nReturns `:ok`.","ref":"Logster.html#log/3"},{"type":"function","title":"Example - Logster.log/3","doc":"```\nLogster.log(:info, service: \"payment-processor\", event: \"start-processing\", customer: \"1234\")\n```\n\nwill produce the following log entry when using the `logfmt` formatter:\n\n```\n16:54:29.919 [info] service=payment-processor event=start-processing customer=1234\n```","ref":"Logster.html#log/3-example"},{"type":"function","title":"Logster.log_conn/3","doc":"Logs details about the given `conn`\n\nSee the module documentation for more information on configuration options.\n\nReturns `:ok`.","ref":"Logster.html#log_conn/3"},{"type":"function","title":"Logster.notice/2","doc":"Logs a notice message. See `Logster.log/3` for more information.\n\nReturns `:ok`.","ref":"Logster.html#notice/2"},{"type":"function","title":"Logster.warning/2","doc":"Logs a warning message. See `Logster.log/3` for more information.\n\nReturns `:ok`.","ref":"Logster.html#warning/2"},{"type":"module","title":"Logster.ChangeConfig","doc":"A plug used to change the logging configuration of Logster. Useful for changing the log level for a specific controller or action.\n\nTo change the configuration for a specific controller, add the following in the controller:\n\n    plug Logster.ChangeConfig, status_2xx_level: :debug, status_4xx_level: :info\n\nTo specify it only for a specific action, add the following:\n\n    plug Logster.ChangeConfig, [status_2xx_level: :debug] when action in [:index, :show]","ref":"Logster.ChangeConfig.html"},{"type":"function","title":"Logster.ChangeConfig.call/2","doc":"","ref":"Logster.ChangeConfig.html#call/2"},{"type":"function","title":"Logster.ChangeConfig.init/1","doc":"","ref":"Logster.ChangeConfig.html#init/1"},{"type":"module","title":"Logster.ChangeLogLevel","doc":"DEPRECATED: Use `Logster.ChangeConfig` instead.\n\nA plug for changing the log level used by Logster. Useful for increasing/decreasing the log level on a per controller or action basis\n\nTo change the log level for a specific controller, add the following in the controller\n\n    plug Logster.ChangeLogLevel, to: :debug\n\nTo specify it only for a specific action, add the following:\n\n    plug Logster.ChangeLogLevel, [to: :debug] when action in [:index, :show]","ref":"Logster.ChangeLogLevel.html"},{"type":"function","title":"Logster.ChangeLogLevel.call/2","doc":"","ref":"Logster.ChangeLogLevel.html#call/2"},{"type":"function","title":"Logster.ChangeLogLevel.init/1","doc":"","ref":"Logster.ChangeLogLevel.html#init/1"},{"type":"module","title":"Logster.Formatters.JSON","doc":"","ref":"Logster.Formatters.JSON.html"},{"type":"function","title":"Logster.Formatters.JSON.format/1","doc":"","ref":"Logster.Formatters.JSON.html#format/1"},{"type":"module","title":"Logster.Formatters.Logfmt","doc":"","ref":"Logster.Formatters.Logfmt.html"},{"type":"function","title":"Logster.Formatters.Logfmt.format/1","doc":"","ref":"Logster.Formatters.Logfmt.html#format/1"},{"type":"module","title":"Logster.Plug","doc":"A plug for logging request information in the format:\n\n    method=GET path=/articles/some-article format=html controller=HelloPhoenix.ArticleController action=show params={\"id\":\"some-article\"} status=200 duration=0.402 state=set\n\nTo use it, just plug it into the desired module.\n\n    plug Logster.Plug, log: :debug","ref":"Logster.Plug.html"},{"type":"module","title":"Options - Logster.Plug","doc":"* `:log` - The log level at which this plug should log its request info.\n    Default is `:info`.","ref":"Logster.Plug.html#module-options"},{"type":"function","title":"Logster.Plug.call/2","doc":"","ref":"Logster.Plug.html#call/2"},{"type":"function","title":"Logster.Plug.init/1","doc":"","ref":"Logster.Plug.html#init/1"},{"type":"extras","title":"Logster","doc":"# Logster\n\n[![CI](https://github.com/navinpeiris/logster/actions/workflows/ci.yml/badge.svg)](https://github.com/navinpeiris/logster/actions/workflows/ci.yml)\n[![Hex version](https://img.shields.io/hexpm/v/logster.svg \"Hex version\")](https://hex.pm/packages/logster)\n[![Hex downloads](https://img.shields.io/hexpm/dt/logster.svg \"Hex downloads\")](https://hex.pm/packages/logster)\n[![License](http://img.shields.io/:license-mit-blue.svg)](http://doge.mit-license.org)\n\n> **Note**\\\n> This is the documentation for v2 of Logster. If you're looking for v1, see the [v1 branch](https://github.com/navinpeiris/logster/tree/v1.x).\n\nAn easy-to-parse, single-line logger for Elixir Phoenix and Plug applications. Supports logfmt, JSON and custom formatting.","ref":"readme.html"},{"type":"extras","title":"Motivation - Logster","doc":"By default, the Phoenix log output for a request looks like:\n\n```text\n[info] GET /articles/some-article\n[debug] Processing with HelloPhoenix.ArticleController.show/2\n  Parameters: %{\"id\" => \"some-article\"}\n  Pipelines: [:browser]\n[info] Sent 200 in 21ms\n```\n\nThis can be handy for development, but cumbersome in production. The log output is spread across multiple lines making it difficult to parse and search.\n\nLogster aims to solve this problem by logging the request in a easy-to-parse single line like:\n\n```text\n[info] state=sent method=GET path=/articles/some-article format=html controller=HelloPhoenix.ArticleController action=show params={\"id\":\"some-article\"} status=200 duration=0.402\n```\n\nThis is especially handy when integrating with log management services such as [Better Stack](https://betterstack.com/telemetry) or [Papertrail](https://papertrailapp.com/).\n\nAlternatively, Logster can also output JSON formatted logs (see configuration section below), or you can provide a custom formatter:\n\n```text\n[info] {\"state\":\"sent\",\"method\":\"GET\",\"path\":\"/articles/some-article\",\"format\":\"html\",\"controller\":\"HelloPhoenix.ArticleController\",\"action\":\"show\",\"params\":{\"id\":\"some-article\"},\"status\":200,\"duration\":0.402}\n```","ref":"readme.html#motivation"},{"type":"extras","title":"Migrating from v1.x to v2.x - Logster","doc":"See [Migration Guide](MIGRATION_GUIDE.md) for more information on migrating from v1.x to v2.x.","ref":"readme.html#migrating-from-v1-x-to-v2-x"},{"type":"extras","title":"Installation - Logster","doc":"Add `:logster` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [{:logster, \"~> 2.0.0-rc.1\"}]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Logster","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Using with Phoenix - Logster","doc":"Attach the Logster Phoenix logger in the `start` function in your project's `application.ex` file:\n\n```elixir\n# lib/my_app/application.ex\ndef start(_type, _args) do\n  children = [\n    # ...\n  ]\n\n  #\n  # Add the line below:\n  #\n  :ok = Logster.attach_phoenix_logger()\n\n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```\n\nNext, disable the default Phoenix logger by adding the following line to your `config.exs` file:\n\n```elixir\n# config/config.exs\nconfig :phoenix, :logger, false\n```","ref":"readme.html#using-with-phoenix"},{"type":"extras","title":"Using with Plug - Logster","doc":"Add `Logster.Plug` to your plug pipeline, or in the relevant module:\n\n```elixir\nplug Logster.Plug\n```","ref":"readme.html#using-with-plug"},{"type":"extras","title":"Using the standalone logger - Logster","doc":"Logster provides `debug`, `info`, `warning`, `error` etc convenience functions that mimic those provided by the elixir logger, which outputs messages in your chosen log format.\n\nFor example:\n\n```elixir\nLogster.info(service: :payments, event: :received, amount: 1000, customer: 123)\n```\n\nwill output the following:\n\n```\n[info] service=payments event=received amount=1000 customer=123\n```\n\nYou can also provide a function to be called lazily, which will only be called if the log level is enabled:\n\n```elixir\nLogster.debug(fn ->\n  # some potentially expensive operation\n  # won't be called if the log level is not enabled\n  customer = get_customer_id()\n\n  [service: :payments, event: :received, amount: 1000, customer: customer]\nend)\n```","ref":"readme.html#using-the-standalone-logger"},{"type":"extras","title":"Configuration - Logster","doc":"","ref":"readme.html#configuration"},{"type":"extras","title":"Application wide - Logster","doc":"You can configure Logster application wide using your `config.exs`, or environment specific config file by providing options like:\n\n```elixir\nconfig :logster,\n  formatter: :json,\n  headers: [\"content-type\"],\n  excludes: [:params]\n```","ref":"readme.html#application-wide"},{"type":"extras","title":"Per request - Logster","doc":"You can then customize each option on a request basis by passing them as options to the `Logster.ChangeConfig` plug in the relevant controller or plug:\n\n```elixir\nplug Logster.ChangeConfig, status_2xx_level: :debug, headers: [\"content-type\", \"x-request-id\"]\n```\n\nor, for specific actions in the controller:\n\n```elixir\nplug Logster.ChangeConfig, [status_2xx_level: :debug, headers: [\"content-type\", \"x-request-id\"]] when action in [:index, :show]\n```\n\nThis is specially useful for cases such as when you want to lower the log level for a healthcheck endpoint that gets hit every few seconds.","ref":"readme.html#per-request"},{"type":"extras","title":"Plug level - Logster","doc":"If you're using the `Logster.Plug` plug, you can also pass options to it directly:\n\n```elixir\nplug Logster.Plug, status_2xx_level: :debug, headers: [\"content-type\", \"x-request-id\"]\n```","ref":"readme.html#plug-level"},{"type":"extras","title":"Configuration options - Logster","doc":"","ref":"readme.html#configuration-options"},{"type":"extras","title":"Formatter - Logster","doc":"#### JSON formatter\n\n```elixir\nconfig :logster, formatter: :json\n```\n\n_Caution:_ There is no guarantee that what reaches your console will be valid JSON. The Elixir `Logger` module has its own formatting which may be appended to your message. See the [Logger documentation](http://elixir-lang.org/docs/stable/logger/Logger.html) for more information.\n\n#### Custom formatter\n\nProvide a function that takes one argument, the parameters as input, and returns formatted output\n\n```elixir\nconfig :logster, formatter: &MyCustomFormatter.format/1\n```","ref":"readme.html#formatter"},{"type":"extras","title":"Log level per status group - Logster","doc":"You can change the log level for each status group by using the following configuration options:\n\n```elixir\nconfig :logster,\n  status_2xx_level: :debug, # default: :info\n  status_3xx_level: :debug, # default: :info\n  status_4xx_level: :info,  # default: :warning\n  status_5xx_level: :error  # default: :error\n```","ref":"readme.html#log-level-per-status-group"},{"type":"extras","title":"Fine grained log level configuration - Logster","doc":"You can specify a function to be called to determine the log level for each request.\n\nThis function will be called with the `conn`, and expects a logger level, or `false` to not log the request as return value.\n\n```elixir\n# config/config.exs\nconfig :logster, log: {MyLoggingModule, :log_level, []}\n```\n\n```elixir\ndefmodule MyLoggingModule do\n  def log_level(%{status: status}) when status >= 500, do: :error\n  def log_level(%{status: status}) when status >= 400, do: :warning\n  def log_level(%{path_info: [\"status\" | _]}), do: false\n  def log_level(_), do: :info\nend\n```","ref":"readme.html#fine-grained-log-level-configuration"},{"type":"extras","title":"Request headers - Logster","doc":"By default, Logster won't log any request headers. To log specific headers, you can use the `:headers` option:\n\n```elixir\nconfig :logster, headers: [\"my-header-one\", \"my-header-two\"]\n```","ref":"readme.html#request-headers"},{"type":"extras","title":"Enabling extra fields - Logster","doc":"One or more of the following fields can be optionally enabled through the `extra_fields` configuration option:\n\n- host\n- query\n\nExample:\n\n```elixir\nconfig :logster, extra_fields: [:host, :query]\n```","ref":"readme.html#enabling-extra-fields"},{"type":"extras","title":"Excluding fields - Logster","doc":"You can exclude fields with `:excludes`:\n\n```elixir\nconfig :logster, excludes: [:params, :status, :state]\n```\n\nExample output:\n\n```\n[info] method=GET path=/articles/some-article format=html controller=HelloPhoenix.ArticleController action=show duration=0.402\n```","ref":"readme.html#excluding-fields"},{"type":"extras","title":"Renaming default fields - Logster","doc":"You can rename the default keys passing a keyword list like:\n\n```elixir\nconfig :logster, renames: [duration: :response_time, params: :parameters]\n```\n\nExample output:\n\n```\n[info] method=GET path=/articles/some-article format=html controller=HelloPhoenix.ArticleController action=show parameters={\"id\":\"some-article\"} status=200 response_time=0.402 state=set\n```","ref":"readme.html#renaming-default-fields"},{"type":"extras","title":"Filtering parameters - Logster","doc":"By default, Logster filters parameters named `password`.\n\nTo change the filtered parameters:\n\n```elixir\nconfig :logster, filter_parameters: [\"password\", \"secret\", \"token\"]\n```","ref":"readme.html#filtering-parameters"},{"type":"extras","title":"Metadata - Logster","doc":"Custom metadata can be added to logs using `Logger.metadata` and configuring your logger backend:\n\n```elixir\n# add metadata for all future logs from this process\nLogger.metadata(%{user_id: \"123\", foo: \"bar\"})\n\n# example for configuring console backend to include metadata in logs.\n# see https://hexdocs.pm/logger/Logger.html#module-console-backend documentation for more\n# config.exs\nconfig :logger, :console, metadata: [:user_id, :foo]\n```\n\nThe easiest way to do this app wide is to introduce a new plug which you can include in your Phoenix router pipeline.\n\nFor example:\n\n```elixir\ndefmodule HelloPhoenix.SetLoggerMetadata do\n  def init(opts), do: opts\n\n  def call(conn, _opts) do\n    Logger.metadata user_id: get_user_id(conn),\n                    remote_ip: format_ip(conn)\n    conn\n  end\n\n  defp format_ip(%{remote_ip: remote_ip}) when remote_ip != nil, do: :inet_parse.ntoa(remote_ip)\n  defp format_ip(_), do: nil\n\n  defp get_user_id(%{assigns: %{current_user: %{id: id}}}), do: id\n  defp get_user_id(_), do: nil\nend\n```\n\nAnd then add this plug to the relevant pipelines in the router:\n\n```elixir\npipeline :browser do\n  plug :fetch_session\n  plug :fetch_flash\n  plug :put_secure_browser_headers\n  # ...\n  plug HelloPhoenix.SetLoggerMetadata\n  # ...\nend\n```","ref":"readme.html#metadata"},{"type":"extras","title":"Development - Logster","doc":"Use the following mix task before pushing commits to run the same checks that are run in CI:\n\n```\nmix ci\n```","ref":"readme.html#development"},{"type":"extras","title":"Acknowledgements - Logster","doc":"This library was inspired by the ruby [lograge](https://github.com/roidrage/lograge) gem.","ref":"readme.html#acknowledgements"},{"type":"extras","title":"License - Logster","doc":"The MIT License\n\nCopyright (c) 2016-present Navin Peiris\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in\nall copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\nTHE SOFTWARE.","ref":"readme.html#license"},{"type":"extras","title":"Migration Guide","doc":"# Migration Guide","ref":"migration_guide.html"},{"type":"extras","title":"v1.x to v2.0.0 - Migration Guide","doc":"","ref":"migration_guide.html#v1-x-to-v2-0-0"},{"type":"extras","title":"Phoenix users: - Migration Guide","doc":"1. Attach the new logger through telemetry events in your project's `application.ex` file:\n\n   ```elixir\n   # lib/pixie/application.ex\n   def start(_type, _args) do\n     children = [\n       # ...\n     ]\n\n     #\n     # Add the line below:\n     #\n     :ok = Logster.attach_phoenix_logger()\n\n     opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n     Supervisor.start_link(children, opts)\n   end\n   ```\n\n2. Locate the line installing `Logster.Plugs.Logger` in your `endpoint.ex` file.\n\n   ```elixir\n   plug Logster.Plugs.Logger,\n     # Configuration options such as those below might not be present\n     formatter: Logster.Plugs.JSONFormatter,\n     allowed_headers: [\"content-type\"],\n     excludes: [:params]\n   ```\n\n3. If configuration options were passed to `Logster.Plugs.Logger`, move them to `config.exs`:\n\n   ```elixir\n   config :logster,\n     formatter: :json,\n     headers: [\"content-type\"],\n     excludes: [:params]\n   ```\n\n   > NOTE: `allowed_headers` option has been renamed to `headers`\n\n4. Remove the line installing `Logster.Plugs.Logger` from your `endpoint.ex` file.\n\n5. Locate any calls to `Logster.Plugs.ChangeLogLevel` and use `Logster.ChangeConfig` plug instead:\n\n   ```diff\n   -  plug Logster.Plugs.ChangeLogLevel, [to: :debug]\n   +  plug Logster.ChangeConfig, [status_2xx_level: :debug]\n   ```\n\n6. Add the following to `config.exs` to disable the default Phoenix logger:\n\n   ```elixir\n   config :phoenix, :logger, false\n   ```","ref":"migration_guide.html#phoenix-users"},{"type":"extras","title":"Plug users: - Migration Guide","doc":"1. Move any configuration options passed to `Logster.Plugs.Logger` to `config.exs` (See above section for more information).\n\n1. Locate any calls to `Logster.Plugs.Logger` and rename it to `Logster.Plug`\n\n   ```diff\n   -  plug Logster.Plugs.Logger\n   +  plug Logster.Plug\n   ```\n\n1. Locate any calls to `Logster.Plugs.ChangeLogLevel` and use `Logster.ChangeConfig` instead.\n\n   ```diff\n   -  plug Logster.Plugs.ChangeLogLevel, [to: :debug]\n   +  plug Logster.ChangeConfig, [status_2xx_level: :debug]\n   ```","ref":"migration_guide.html#plug-users"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}